org.icefaces.ace.component.stackpane

## Class StackPaneBase

- java.lang.Object
- - javax.faces.component.UIComponent
  - - javax.faces.component.UIComponentBase
    - - javax.faces.component.UIPanel
      - - org.icefaces.ace.component.stackpane.StackPaneBase

- All Implemented Interfaces:
    java.util.EventListener, javax.faces.component.PartialStateHolder, javax.faces.component.StateHolder, javax.faces.component.TransientStateHolder, javax.faces.event.ComponentSystemEventListener, javax.faces.event.FacesListener, javax.faces.event.SystemEventListenerHolder, IStackPane
  Direct Known Subclasses:
    StackPane

      public abstract class StackPaneBase
      extends javax.faces.component.UIPanel
      implements IStackPane

  This component is a child of panelStack.The facelet attribute determines whether the children of this component are constructed in the server side component tree. A special tag handler is utilised to assist with this task. The desired outcome of this feature is to allow developers to maintain as small a server-side component tree as possible for purposes of increased scalability, without having to worry about the combinatory use of ui include and c forEach tags used with components.The facelet attribute defaults to false meaning that this panel is constructed and present in server side component tree. If facelet is true (can only be so if client is false), then the stackPane is only constructed if it is the selected panel in the panelStack.If the client attribute is true, this means children of this component are not only constructed but area also always rendered on the client --best for static data.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `StackPaneBase.PropertyKeys`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `COMPONENT_TYPE`
    `static java.lang.String` | `RENDERER_TYPE`

    - ### Fields inherited from class javax.faces.component.UIPanel

      `COMPONENT_FAMILY`

    - ### Fields inherited from class javax.faces.component.UIComponent

      `ATTRS_WITH_DECLARED_DEFAULT_VALUES, BEANINFO_KEY, bindings, COMPOSITE_COMPONENT_TYPE_KEY, COMPOSITE_FACET_NAME, CURRENT_COMPONENT, CURRENT_COMPOSITE_COMPONENT, FACETS_KEY, HONOR_CURRENT_COMPONENT_ATTRIBUTES_PARAM_NAME, VIEW_LOCATION_KEY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `StackPaneBase()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getFamily()`
    `java.lang.String` | `getStyle()` Return the value of the `style` property.
    `java.lang.String` | `getStyleClass()` Return the value of the `styleClass` property.
    `boolean` | `isClient()` Return the value of the `client` property.
    `boolean` | `isFacelet()` Return the value of the `facelet` property.
    `protected boolean` | `isPropertySet(java.lang.String finder)`
    `java.lang.Boolean` | `isSelected()` Return the value of the `selected` property.
    `void` | `setClient(boolean client)` Set the value of the `client` property.
    `void` | `setFacelet(boolean facelet)` Set the value of the `facelet` property.
    `void` | `setSelected(java.lang.Boolean selected)` Set the value of the `selected` property.
    `void` | `setStyle(java.lang.String style)` Set the value of the `style` property.
    `void` | `setStyleClass(java.lang.String styleClass)` Set the value of the `styleClass` property.
    `void` | `setValueExpression(java.lang.String name, javax.el.ValueExpression binding)`

    - ### Methods inherited from class javax.faces.component.UIComponentBase

      `addClientBehavior, addFacesListener, broadcast, clearInitialState, decode, encodeBegin, encodeChildren, encodeEnd, findComponent, getAttributes, getChildCount, getChildren, getClientBehaviors, getClientId, getDefaultEventName, getEventNames, getFacesContext, getFacesListeners, getFacet, getFacetCount, getFacets, getFacetsAndChildren, getId, getListenersForEventClass, getParent, getRenderer, getRendererType, getRendersChildren, getValueBinding, invokeOnComponent, isRendered, isTransient, markInitialState, processDecodes, processRestoreState, processSaveState, processUpdates, processValidators, queueEvent, removeFacesListener, restoreAttachedState, restoreState, saveAttachedState, saveState, setId, setParent, setRendered, setRendererType, setTransient, setValueBinding, subscribeToEvent, unsubscribeFromEvent`

    - ### Methods inherited from class javax.faces.component.UIComponent

      `encodeAll, getClientId, getCompositeComponentParent, getContainerClientId, getCurrentComponent, getCurrentCompositeComponent, getNamingContainer, getResourceBundleMap, getStateHelper, getStateHelper, getTransientStateHelper, getTransientStateHelper, getValueExpression, initialStateMarked, isCompositeComponent, isInView, isVisitable, popComponentFromEL, processEvent, pushComponentToEL, restoreTransientState, saveTransientState, setInView, visitTree`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### COMPONENT_TYPE

          public static final java.lang.String COMPONENT_TYPE

      See Also:
        Constant Field Values

    - #### RENDERER_TYPE

          public static final java.lang.String RENDERER_TYPE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### StackPaneBase

          public StackPaneBase()

  - ### Method Detail

    - #### getFamily

          public java.lang.String getFamily()

      Overrides:
        `getFamily` in class `javax.faces.component.UIPanel`

    - #### setClient

          public void setClient(boolean client)

      Set the value of the `client` property.

      Contents: If this attribute evaluates to "true", the stackPane's children are always rendered to the client/browser. This is ideal for static content. The facelet attribute is only relevant if this attribute is false.

      Specified by:
        `setClient` in interface `IStackPane`

    - #### isClient

          public boolean isClient()

      Return the value of the `client` property.

      Contents: If this attribute evaluates to "true", the stackPane's children are always rendered to the client/browser. This is ideal for static content. The facelet attribute is only relevant if this attribute is false. Default = 'false'.

      Specified by:
        `isClient` in interface `IStackPane`

    - #### setFacelet

          public void setFacelet(boolean facelet)

      Set the value of the `facelet` property.

      Contents: If this attribute is "true" the component utilizes the StackPaneHandler to optimise server-side performance by reducing the size of the server-side component tree. Any non-selected stackPane will not have its children added to the component tree. If this attribute evaluates to "false", then normal jsf construction of the component tree occurs. Must have client="false" which is the default value for that attribute.. Default value for this attribute is false.

      Specified by:
        `setFacelet` in interface `IStackPane`

    - #### isFacelet

          public boolean isFacelet()

      Return the value of the `facelet` property.

      Contents: If this attribute is "true" the component utilizes the StackPaneHandler to optimise server-side performance by reducing the size of the server-side component tree. Any non-selected stackPane will not have its children added to the component tree. If this attribute evaluates to "false", then normal jsf construction of the component tree occurs. Must have client="false" which is the default value for that attribute.. Default value for this attribute is false. Default = 'false'.

      Specified by:
        `isFacelet` in interface `IStackPane`

    - #### setStyle

          public void setStyle(java.lang.String style)

      Set the value of the `style` property.

      Contents: Style to apply to the container element.

      Specified by:
        `setStyle` in interface `IStackPane`

    - #### getStyle

          public java.lang.String getStyle()

      Return the value of the `style` property.

      Contents: Style to apply to the container element.

      Specified by:
        `getStyle` in interface `IStackPane`

    - #### setStyleClass

          public void setStyleClass(java.lang.String styleClass)

      Set the value of the `styleClass` property.

      Contents: Style class to apply to the container element.

      Specified by:
        `setStyleClass` in interface `IStackPane`

    - #### getStyleClass

          public java.lang.String getStyleClass()

      Return the value of the `styleClass` property.

      Contents: Style class to apply to the container element.

      Specified by:
        `getStyleClass` in interface `IStackPane`

    - #### setSelected

          public void setSelected(java.lang.Boolean selected)

      Set the value of the `selected` property.

      Specified by:
        `setSelected` in interface `IStackPane`

    - #### isSelected

          public java.lang.Boolean isSelected()

      Return the value of the `selected` property.

      Specified by:
        `isSelected` in interface `IStackPane`

    - #### isPropertySet

          protected boolean isPropertySet(java.lang.String finder)

    - #### setValueExpression

          public void setValueExpression(java.lang.String name,
                                         javax.el.ValueExpression binding)

      Overrides:
        `setValueExpression` in class `javax.faces.component.UIComponent`

Copyright 2025 ICEsoft Technologies Canada, Corp. All Rights Reserved.